C-fpp- =================================================================
C-fpp- fpp -- C version 1.0.5 [06-Apr-1991]
C-fpp- Date: Wed Aug 14 17:17:52 1991
C-fpp- Directory: /export/local/sun4/plot79/sf3dir
C-fpp- User: Nelson H.F. Beebe <beebe@csc-sun.math.utah.edu>
C-fpp- Macro: _OS_UNIX=1
C-fpp- Macro: _BSD=1
C-fpp- Macro: _SUN=1
C-fpp- Macro: _SUN4=1
C-fpp- Macro: _BIG_ENDIAN=1
C-fpp- Macro: _IEEE_754=1
C-fpp- Macro: _NAMELIST=1
C-fpp- =================================================================
      SUBROUTINE  SYSDEC (NSF3,NSFL,NFOR,NINCL,NTEMP1,NTEMP2,NERR)
C#if _OS_UNIX
C     (System File Assignments)
C     This  version  is specific for Unix and assumes  that NSF3,
C     NFOR, and NERR are respectively 5,  6,  and  0,  which  are
C     pre-assigned  to  stdin,  stdout,  and  stderr;   they  are
C     therefore not opened.
C
C     The command line is assumed to look like
C
C     progname [<sf3-file] [>for-file] sfl-file inc-file -s1 -s2 ...
C
C     where  switches  may appear in any order on the line  since
C     they begin with the distinct character  '-'  which  is  not
C     used in file names.   Stdin, stdout, and stderr are used to
C     encourage the use of pipelines and command-line redirection
C     in Unix.
C
C     The temporary files are opened as scratch files.  If either
C     of  the sfl-file or inc-file names cannot be found,  or are
C     blank, (which can be specified on the  command  line  as  a
C     null  string,  ""  or ''), they are opened for the  special
C     Unix empty file, /dev/null.
C     (08-Mar-1993)
      INTEGER           NSF3,NSFL,NFOR,NINCL,NTEMP1,NTEMP2,NERR
      INTEGER           I,P79ARC,IOS,KASE,LENARG,NARGS,CHRLEN
      CHARACTER*144     CMDARG
C
      NARGS = P79ARC()
      KASE = 0
      I = 0
20001 IF (.NOT.((I .LT. NARGS) .AND. (KASE .LT. 2))) GO TO 20002
      I = I + 1
      CALL P79ARG (I,CMDARG)
      IF (.NOT.(CMDARG(1:1) .NE. '-')) GO TO 20003
      LENARG = CHRLEN(CMDARG,144)
      KASE = KASE + 1
      IF (.NOT.(KASE .EQ. 1)) GO TO 20006
      IF (LENARG .EQ. 0) CMDARG = '/dev/null'
      OPEN (UNIT=NSFL,FILE=CMDARG,ACCESS='sequential',
     XFORM='formatted',STATUS='unknown',IOSTAT=IOS)
      IF (IOS .NE. 0)
     XSTOP 'Open failure on .sfl file'
      GO TO 20007
20006 IF (.NOT.(KASE .EQ. 2)) GO TO 10001
      IF (LENARG .EQ. 0) CMDARG = '/dev/null'
      OPEN (UNIT=NINCL,FILE=CMDARG,ACCESS='sequential',
     XFORM='formatted',STATUS='old',IOSTAT=IOS)
      IF (IOS .NE. 0)
     XSTOP 'Open failure on .inc file'
10001 CONTINUE
20007 CONTINUE
20008 CONTINUE
20003 CONTINUE
20004 GO TO 20001
C
20002 CMDARG = '/dev/null'
      IF (.NOT.(KASE .LE. 0)) GO TO 20009
      OPEN (UNIT=NSFL,FILE=CMDARG,ACCESS='sequential',
     XFORM='formatted',STATUS='unknown',IOSTAT=IOS)
      IF (IOS .NE. 0)
     XSTOP 'Open failure on .sfl file'
C
20009 IF (.NOT.(KASE .LE. 1)) GO TO 20012
      OPEN (UNIT=NINCL,FILE=CMDARG,ACCESS='sequential',
     XFORM='formatted',STATUS='old',IOSTAT=IOS)
      IF (IOS .NE. 0)
     XSTOP 'Open failure on .inc file'
C
20012 OPEN (UNIT=NTEMP1,ACCESS='sequential',FORM='formatted',
     XSTATUS='scratch',IOSTAT=IOS)
      IF (IOS .NE. 0)
     XSTOP 'Open failure on temporary file 1'
C
      OPEN (UNIT=NTEMP2,ACCESS='sequential',FORM='formatted',
     XSTATUS='scratch',IOSTAT=IOS)
      IF (IOS .NE. 0)
     XSTOP 'Open failure on temporary file 2'
C
C     Unix  leaves files positioned at end-of-file after  opening
C     them, so  rewind  them.   This  is  not  permitted  on  the
C     standard units.
C
      REWIND NSFL
      REWIND NINCL
      REWIND NTEMP1
      REWIND NTEMP2
C
      RETURN
C#else
C##C$    (DECSYSTEM-20 I/O Initialization)
C##C$    File names are expected in the order input and output,  and
C##C$    may be supplied from one of three possible sources.   These
C##C$    are:
C##C$
C##C$    1) the command line;
C##C$    2) a command file named "PRGNAM.CMD", where PRGNAM
C##C$       is the name of the program being run (i.e. the
C##C$       name of the .EXE executable file);
C##C$    3) from the TTY:, which is either the interactive
C##C$       terminal, or a batch job control file;
C##C$
C##C$    The search occurs in this order, and terminates when one of
C##C$    the three supplies the expected  file names.  If the  names
C##C$    are supplied without file extensions, the default of ".DAT"
C##C$    is assumed for the input file, and the input file extension
C##C$    is assumed for the output file extension.  The names  "TTY"
C##C$    or "TTY:" are  acceptable, and will  assign the  associated
C##C$    file to  the  interactive  terminal or  to  the  batch  job
C##C$    control file.
C##C$
C##C$    The files  are expected  in the  order: 1)  input  SFTRAN/3
C##C$    source file,  2)  output SFTRAN/3  structured  listing,  3)
C##C$    output FORTRAN file, and 4) optional SFTRAN/3 INCLUDE file.
C##C$    In addition to the  4 files NIN, NPRT,  NFOR, and NINCL,  a
C##C$    scratch file  is  opened for  NTEMP1  and NTEMP2  with  the
C##C$    extensions ".TM1" and ".TM2", and a log file is opened  for
C##C$    NERR to the TTY: device.
C##C$    (12-MAR-83)
C##      DOUBLE PRECISION BLANK,       DSK,         DUMMY,       FILE(4)
C##      DOUBLE PRECISION LAST
C##      DOUBLE PRECISION NAME,        SCR,         SF3FIL,      TTY
C##      INTEGER          MAXFIL,      NERR,        NFOR,        NIN
C##      INTEGER          NINCL,       NPRMPT,      NPRT,        NTEMP1
C##      INTEGER          NTEMP2,      NTTY,        NUMFIL,      NUMSW
C##      INTEGER          NUSE,        P79OPT,      PRGNAM(6),   SYSCDF
C##      INTEGER          IDUMMY
C##      LOGICAL          CMDLIN,      ERROR,       USETTY
C##INCLUDE,L (SYSCB1)
C##C$
C##      DATA TTY/4HTTY:/
C##      DATA DSK/4HDSK:/, SCR/4HSCR:/
C##      DATA BLANK/10H          /
C##      DATA NPRMPT/-4/, MAXFIL/4/, NTTY/-4/
C##C$
C##C$    Try to find the file names on the command line.
C##C$
C##      CALL SYSCMD (FILE,MAXFIL,NUMFIL,DUMMY,IDUMMY,0,NUMSW)
C##      CMDLIN = (NUMFIL .GT. 0)
C##      USETTY = .FALSE.
C##      NUSE = NPRMPT
C##      IF (CMDLIN) NUSE = 0
C##      IF (CMDLIN) GO TO 10
C##C$
C##C$    Get the program name and construct a file name "PRGNAM.CMD"
C##C$
C##      NAME = BLANK
C##      CALL SYSGPN (PRGNAM)
C##      CALL KARPAK (NAME,1,PRGNAM,6)
C##      LAST = NAME
C##      CALL SYSPFE (NAME,4H.CMD)
C##C$
C##C$    Try to open "PRGNAM.CMD".  If it fails, use the TTY for input.
C##C$
C##      CALL SYSOPN (NUSE,NAME,DSK,5HSEQIN,5HASCII,4HSAVE,ERROR)
C##      USETTY = ERROR
C##C$
C##C$    Open NIN.
C##C$
C##   10 IF (USETTY) WRITE (NTTY,1000)
C##      IF (CMDLIN) NAME = FILE(1)
C##      CALL SYSFIL (NUSE,NIN,NAME,LAST,4H.SF3,5HSEQIN,5HASCII,
C##     X             4HSAVE,ERROR)
C##      SF3FIL = NAME
C##      IF (ERROR) WRITE (NTTY,5000) NAME
C##      IF (ERROR) STOP
C##C$
C##C$    If the FORTRAN file already  exists, and is newer than  the
C##C$    SFTRAN3 file, then stop processing immediately, unless  the
C##C$    /R option has been  specified to force reprocessing.   This
C##C$    avoids  unnecessary  work,  in   the  same  way  that   the
C##C$    COMPILE/LOAD/EXECUTE  commands   never  cause   unnecessary
C##C$    recompilation unless  forced  to.  This  shortcut  will  be
C##C$    taken only if the files  come from the command line,  since
C##C$    the open in SYSFIL will always create a new generation,  so
C##C$    that we cannot check after calling it.
C##C$
C##      NAME = LAST
C##      IF (CMDLIN .AND. (NUMFIL .GE. 3)) NAME = FILE(3)
C##      CALL SYSPFE (NAME,4H.FOR)
C##      IF (CMDLIN .AND. (P79OPT(1HR) .EQ. -1) .AND.
C##     X     (SYSCDF(SF3FIL,10,NAME,10) .EQ. +1)) STOP
C##C$
C##C$    Open NPRT.
C##C$
C##      IF (USETTY) WRITE (NTTY,2000)
C##      NAME = LAST
C##      IF (CMDLIN .AND. (NUMFIL .GE. 2)) NAME = FILE(2)
C##      CALL SYSFIL (NUSE,NPRT,NAME,LAST,4H.SFL,6HSEQOUT,5HASCII,
C##     X             4HSAVE,ERROR)
C##      IF (ERROR) WRITE (NTTY,5000) NAME
C##      IF (ERROR) STOP
C##C$
C##C$    Open NFOR using binary IMAGE  mode.  Routine OUTLN will  do
C##C$    all output to this file.
C##C$
C##      IF (USETTY) WRITE (NTTY,3000)
C##      NAME = LAST
C##      IF (CMDLIN .AND. (NUMFIL .GE. 3)) NAME = FILE(3)
C##      CALL SYSFIL (NUSE,NFOR,NAME,LAST,4H.FOR,6HSEQOUT,5HIMAGE,
C##     X             4HSAVE,ERROR)
C##      IF (ERROR) WRITE (NTTY,5000) NAME
C##      IF (ERROR) STOP
C##      FORFIL = NAME
C##C$
C##C$    Open NINCL.   If  the  open fails,  retry  with  the  names
C##C$    "SFTRAN.INC" and "SF3.INC". If it fails again, set NINCL  =
C##C$    0 but do not terminate execution. An INCLUDE file need  not
C##C$    exist to use SFTRAN.
C##C$
C##      IF (USETTY) WRITE (NTTY,4000)
C##      NAME = LAST
C##      IF (CMDLIN .AND. (NUMFIL .GE. 4)) NAME = FILE(4)
C##      CALL SYSFIL (NUSE,NINCL,NAME,LAST,4H.INC,5HSEQIN,5HASCII,
C##     X             4HSAVE,ERROR)
C##      IF (ERROR) CALL SYSOPN (NINCL,10HSFTRAN.INC,DSK,
C##     X     5HSEQIN,5HASCII,4HSAVE,ERROR)
C##      IF (ERROR) CALL SYSOPN (NINCL,7HSF3.INC,DSK,
C##     X     5HSEQIN,5HASCII,4HSAVE,ERROR)
C##      IF (ERROR) NINCL = 0
C##C$
C##C$    Open NTEMP1, assuming the same file name as the previous
C##C$    files, but with extension ".TM1".
C##C$
C##      NAME = LAST
C##      CALL SYSPFE (NAME,4H.TM1)
C##      CALL SYSOPN (NTEMP1,NAME,SCR,8HSEQINOUT,6HBINARY,6HDELETE,ERROR
C##      IF (ERROR) WRITE (NTTY,5000) NAME
C##      IF (ERROR) STOP
C##C$
C##C$    Open NTEMP2, assuming  the same file  name as the  previous
C##C$    files, but with extension ".TM2".
C##C$
C##      NAME = LAST
C##      CALL SYSPFE (NAME,4H.TM2)
C##      CALL SYSOPN (NTEMP2,NAME,SCR,8HSEQINOUT,6HBINARY,6HDELETE,ERROR
C##      IF (ERROR) WRITE (NTTY,5000) NAME
C##      IF (ERROR) STOP
C##C$
C##C$    Open NERR to the TTY device.
C##C$
C##      CALL SYSOPN (NERR,BLANK,TTY,6HSEQOUT,5HASCII,4HSAVE,ERROR)
C##      IF (ERROR) WRITE (NTTY,5000) TTY
C##      IF (ERROR) STOP
C##C$
C##      RETURN
C##C$
C## 1000 FORMAT (14H+Input File = ,$)
C## 2000 FORMAT (27H+Structured Listing File = ,$)
C## 3000 FORMAT (16H+FORTRAN File = ,$)
C## 4000 FORMAT (16H+Include File = ,$)
C## 5000 FORMAT (/21H ?*** ERROR *** File ,A10,21H could NOT be opened.)
C#endif
      END
